## unison 2.40.65

=== debian/changelog ===
unison (2.40.65-1ubuntu1) precise; urgency=low

  * debian/rules: do not compress unison-manual.txt 
  * Resynchronise with Debian. Remaining changes:
    - Change default logfile directory to .unison by prepending .unison to
      name of logfile in ubase/trace.ml.

 -- Julian Taylor <jtaylor@ubuntu.com>  Thu, 05 Apr 2012 20:33:03 +0200

unison (2.40.65-1) unstable; urgency=low

  * New upstream release
    - fix -doc option (Closes: #657496, LP: #949895)

 -- Stéphane Glondu <glondu@debian.org>  Mon, 02 Apr 2012 17:55:06 +0200

unison (2.40.63-3) unstable; urgency=low

  * Suggest unison-all
  * Use rsvg-convert instead of rsvg (Closes: #666312)

 -- Stéphane Glondu <glondu@debian.org>  Sat, 31 Mar 2012 19:16:19 +0200

unison (2.40.63-2ubuntu1) precise; urgency=low

  * debian/rules: use rsvg-convert, rsvg does note exist anymore
  * Resynchronise with Debian (LP: #933015).  Remaining changes:
    - Change default logfile directory to .unison by prepending .unison to
      name of logfile in ubase/trace.ml.

 -- Julian Taylor <jtaylor@ubuntu.com>  Wed, 15 Feb 2012 21:58:05 +0100

unison (2.32.52-3ubuntu1) oneiric; urgency=low

  * Resynchronise with Debian (LP: #832861).  Remaining changes:
    - Change default logfile directory to .unison by prepending .unison to
      name of logfile in ubase/trace.ml.
  * Fix link order to list C objects before the libraries they require.

 -- Colin Watson <cjwatson@ubuntu.com>  Sat, 10 Sep 2011 12:22:38 +0100

unison (2.32.52-1ubuntu2) maverick; urgency=low

  * Refresh change-logfile-location.dpatch.

 -- Ilya Barygin <barygin@gmail.com>  Sat, 08 May 2010 14:37:17 +0000

unison (2.32.52-1ubuntu1) maverick; urgency=low

  * Merge from Debian unstable, remaining changes:
    - Change default logfile directory to .unison by prepending
      .unison to name of logfile in ubase/trace.ml. For this reason
      debian/patches/00list still include change-logfile-location
  * New upstream version fixes bugs:
    - file permissions probem, LP: #304453
    - slowliness on large files, LP: #394895
    - "Failed: Not_found" after directory rename, LP: #569647

 -- Ilya Barygin <barygin@gmail.com>  Sat, 08 May 2010 13:56:17 +0000

unison (2.27.57-2ubuntu2) lucid; urgency=low

  * No-change rebuild for OCaml 3.11.2 transition (LP: #527627).

 -- Ilya Barygin <barygin@gmail.com>  Thu, 25 Feb 2010 20:53:22 +0300

unison (2.27.57-2ubuntu1) karmic; urgency=low

  * Merge from debian unstable (LP: #377652), remaining changes:
    - Change default logfile directory to .unison by prepending
      .unison to name of logfile in ubase/trace.ml. For this reason
      debian/patches/00list still include change-logfile-location

 -- Andreas Olsson <andol@ubuntu.com>  Mon, 03 Aug 2009 20:32:54 +0200

unison (2.27.57-1ubuntu1) intrepid; urgency=low

  * Change default logfile directory to .unison
    by prepending .unison to name of logfile in ubase/trace.ml
    (Closes: LP #234365)
  * Change Maintainer to Ubuntu MOTU Developers

 -- Tan Rui Boon <ruiboon@gmail.com>  Sun, 08 Jun 2008 00:19:02 +0800

=== debian/control ===
Source: unison
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Stéphane Glondu <glondu@debian.org>
Build-Depends: cdbs (>= 0.4.23),
 debhelper (>= 7),
 ocaml-nox (>= 3.10.0-8),
 liblablgtk2-ocaml-dev (>= 2.12.0-2),
 chrpath,
 librsvg2-bin (>= 2.18.2),
 imagemagick,
 dh-ocaml (>= 0.9.1)
Standards-Version: 3.9.2
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/unison.git
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/unison.git
Homepage: http://www.cis.upenn.edu/~bcpierce/unison/

Package: unison
Architecture: any
Depends: ${shlibs:Depends}, ${ocaml:Depends}, ${misc:Depends}
Recommends: ssh-client | openssh-client
Suggests: unison-all
Replaces: ${F:OtherUnison}
Breaks: ${F:OtherUnison}
Description: file-synchronization tool for Unix and Windows
 Unison is a file-synchronization tool for Unix and Windows, written
 in OCaml. It allows two replicas of a collection of files and
 directories to be stored on different hosts (or different disks
 on the same host), modified separately, and then brought up to
 date by propagating the changes in each replica to the other.
 .
 Unison offers several advantages over various synchronization methods
 such as CVS, Coda, rsync, Intellisync, etc. Unison can run on and
 synchronize between Windows and many UNIX platforms. Unison requires
 no root privileges, system access or kernel changes to function. Unison
 can synchronize changes to files and directories in both directions,
 on the same machine, or across a network using ssh or a direct
 socket connection.
 .
 Transfers are optimised using a version of the rsync protocol,
 making it ideal for slower links. Unison has a clear and precise
 specification, and is resilient to failure due to its careful
 handling of the replicas and its private structures.

Package: unison-gtk
Architecture: any
Depends: ${shlibs:Depends}, ${ocaml:Depends}, ${misc:Depends}
Replaces: ${F:OtherUnisonGtk}
Breaks: ${F:OtherUnisonGtk}
Recommends: ssh-askpass, ssh-client | openssh-client
Suggests: unison-all-gtk
Description: file-synchronization tool for Unix and Windows with GTK+ interface
 Unison is a file-synchronization tool for Unix and Windows, written
 in OCaml. It allows two replicas of a collection of files and
 directories to be stored on different hosts (or different disks
 on the same host), modified separately, and then brought up to
 date by propagating the changes in each replica to the other.
 .
 Unison offers several advantages over various synchronization methods
 such as CVS, Coda, rsync, Intellisync, etc. Unison can run on and
 synchronize between Windows and many UNIX platforms. Unison requires
 no root privileges, system access or kernel changes to function. Unison
 can synchronize changes to files and directories in both directions,
 on the same machine, or across a network using ssh or a direct
 socket connection.
 .
 Transfers are optimised using a version of the rsync protocol,
 making it ideal for slower links. Unison has a clear and precise
 specification, and is resilient to failure due to its careful
 handling of the replicas and its private structures.
 .
 This package adds the optional GTK+ interface.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for unison package
# Copyright (C) 2006-2009 Sylvain Le Gall <gildor@debian.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
# MA 02110-1301, USA.

include /usr/share/cdbs/1/rules/ocaml.mk
include /usr/share/cdbs/1/rules/debhelper.mk

VERSION=$(DEB_UPSTREAM_VERSION)
# version used with addversionno in unison
VERSIONNO=$(shell echo $(VERSION) | cut -f 1-2 -d .)

ifeq ($(DEB_SOURCE_PACKAGE),unison)
# latest package
PACKAGE_VERSION=
PRIORITY=20
# unison-gtk can replaced unison
PRIORITY_GTK=15
else
# compatibility package
PACKAGE_VERSION=$(VERSION)
PRIORITY=10
PRIORITY_GTK=5
endif

TR=$(subst .,_,$(subst -,_,$1))

UNISON=unison-$(VERSION)
UNISON_MAJ=UNISON-$(VERSION)
UNISON_PACKAGE=unison$(PACKAGE_VERSION)
UNISON_ALTERNATIVE=$(if $(PACKAGE_VERSION),$(UNISON),unison-latest-stable)
UNISON_VERSIONNO=unison-$(VERSIONNO)
UNISON_VAR=$(call TR,$(UNISON))

UNISON_GTK=unison-$(VERSION)-gtk
UNISON_GTK_PACKAGE=$(UNISON_PACKAGE)-gtk
UNISON_GTK_ALTERNATIVE=$(if $(PACKAGE_VERSION),$(UNISON_GTK),unison-latest-stable-gtk)
UNISON_GTK_VERSIONNO=unison-$(VERSIONNO)-gtk
UNISON_GTK_VAR=$(call TR,$(UNISON_GTK))

RENAME := debian/unison.1.in
RENAME += debian/unison.doc-base.in
RENAME += debian/unison-gtk.menu.in
RENAME += debian/unison-gtk.svg.in
RENAME += debian/unison-gtk.install.in
RENAME += debian/unison.install.in
RENAME += debian/unison-gtk.desktop.in

ifeq ($(DEB_SOURCE_PACKAGE),unison)
OTHER_UNISON_PACKAGE=unison$(VERSION)
OTHER_UNISON_GTK_PACKAGE=unison$(VERSION)-gtk
else
OTHER_UNISON_PACKAGE=unison (<< $(VERSION)-999)
OTHER_UNISON_GTK_PACKAGE=unison-gtk (<< $(VERSION)-999)
endif
DEB_DH_GENCONTROL_ARGS += -- "-VF:OtherUnisonGtk=$(OTHER_UNISON_GTK_PACKAGE)" "-VF:OtherUnison=$(OTHER_UNISON_PACKAGE)"


MY_MAKE_FLAGS += $(shell if test -x /usr/bin/ocamlopt.opt; then echo "OCAMLOPT=ocamlopt.opt"; fi )

ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
  NATIVE := true
else
  NATIVE := false
  DEB_STRIP_EXCLUDE := $(UNISON) $(UNISON_GTK)
endif

UISTYLE := $(shell dpkg --compare-versions 2.10 ge $(VERSION) && echo gtk || echo gtk2)

DEB_INSTALL_DOCS_ALL := BUGS.txt TODO.txt unison-manual.txt -X unison.doc-base.in

DEB_INSTALL_CHANGELOGS_ALL := NEWS

DEB_COMPRESS_EXCLUDE_ALL := unison-manual.txt

#
# Build unison
#

configure::
	cp config/Makefile.unix config/Makefile

build/$(UNISON_PACKAGE)::
	$(MAKE) UISTYLE=text NATIVE=$(NATIVE) $(MY_MAKE_FLAGS) CFLAGS=
	mv '$(CURDIR)/unison' '$(CURDIR)/$(UNISON)'

build/$(UNISON_GTK_PACKAGE):: debian/$(UNISON_GTK_PACKAGE).xpm
	$(MAKE) UISTYLE=$(UISTYLE) NATIVE=$(NATIVE) $(MY_MAKE_FLAGS) CFLAGS=
	mv '$(CURDIR)/unison' '$(CURDIR)/$(UNISON_GTK)'
	if test 'x$(OCAML_HAVE_OCAMLOPT)' = 'xyes'; then /usr/bin/chrpath -d '$(CURDIR)/$(UNISON_GTK)'; fi

clean::
	-$(RM) '$(CURDIR)/$(UNISON_GTK)'
	-$(RM) '$(CURDIR)/$(UNISON)'
	$(MAKE) clean
	rm lwt/depend ubase/depend

debian/unison-manual.txt: build/$(UNISON_PACKAGE)
	env HOME='$(CURDIR)' '$(CURDIR)/$(UNISON)' -doc all > '$(CURDIR)/unison-manual.txt'

debian/unison.1.in: build/$(UNISON_PACKAGE)
	cp debian/unison-intro.1.in debian/unison.1.in
	env HOME='$(CURDIR)' ocaml debian/generate-manpage.ml '$(CURDIR)/$(UNISON)' >> debian/unison.1.in
	cat debian/unison-outro.1.in >> debian/unison.1.in

clean::
	-$(RM) unison-manual.txt
	-$(RM) debian/unison.1.in

common-binary-arch:: debian/unison-manual.txt debian/unison.1.in

#
# Unison icons
#

debian/$(UNISON_GTK_PACKAGE).png: debian/unison-gtk.svg.in
	 rsvg-convert -f png -w 32 -h 32 -o $@ $^

debian/$(UNISON_GTK_PACKAGE).xpm: debian/$(UNISON_GTK_PACKAGE).png
	convert $^ $@

clean::
	-$(RM) '$(CURDIR)/debian/$(UNISON_GTK_PACKAGE).png'
	-$(RM) '$(CURDIR)/debian/$(UNISON_GTK_PACKAGE).xpm'

#
# Generate debhelper files using templates
#

SED_REPLACE += -e "s/@VERSION@/$(VERSION)/g"
SED_REPLACE += -e "s/@PACKAGE_VERSION@/$(PACKAGE_VERSION)/g"

SED_REPLACE += -e "s/@PRIORITY@/$(PRIORITY)/g"
SED_REPLACE += -e "s/@UNISON@/$(UNISON)/g"
SED_REPLACE += -e "s/@UNISON_PACKAGE@/$(UNISON_PACKAGE)/g"
SED_REPLACE += -e "s/@UNISON_ALTERNATIVE@/$(UNISON_ALTERNATIVE)/g"
SED_REPLACE += -e "s/@UNISON_VERSIONNO@/$(UNISON_VERSIONNO)/g"
SED_REPLACE += -e "s/@UNISON_VAR@/$(UNISON_VAR)/g"
SED_REPLACE += -e "s/@UNISON_MAJ@/$(UNISON_MAJ)/g"

SED_REPLACE += -e "s/@PRIORITY_GTK@/$(PRIORITY_GTK)/g"
SED_REPLACE += -e "s/@UNISON_GTK@/$(UNISON_GTK)/g"
SED_REPLACE += -e "s/@UNISON_GTK_PACKAGE@/$(UNISON_GTK_PACKAGE)/g"
SED_REPLACE += -e "s/@UNISON_GTK_ALTERNATIVE@/$(UNISON_GTK_ALTERNATIVE)/g"
SED_REPLACE += -e "s/@UNISON_GTK_VERSIONNO@/$(UNISON_GTK_VERSIONNO)/g"
SED_REPLACE += -e "s/@UNISON_GTK_VAR@/$(UNISON_GTK_VAR)/g"

SED_REPLACE += -e "s/@PRIORITY_SELF@/$(PRIORITY_SELF)/g"
SED_REPLACE += -e "s/@UNISON_SELF@/$(UNISON_SELF)/g"
SED_REPLACE += -e "s/@UNISON_SELF_PACKAGE@/$(UNISON_SELF_PACKAGE)/g"
SED_REPLACE += -e "s/@UNISON_SELF_ALTERNATIVE@/$(UNISON_SELF_ALTERNATIVE)/g"
SED_REPLACE += -e "s/@UNISON_SELF_VERSIONNO@/$(UNISON_SELF_VERSIONNO)/g"
SED_REPLACE += -e "s/@UNISON_SELF_VAR@/$(UNISON_SELF_VAR)/g"
SED_REPLACE += -e "s/@IS_GTK@/$(IS_GTK)/g"

%-template-stamp: $(wildcard debian/templates/*)
	for i in $^ ; do   \
	   sed $(SED_REPLACE) $$i > debian/$(UNISON_SELF_PACKAGE).$$(basename $$i); \
	done;
	touch $@

clean::
	for i in $(wildcard debian/templates/*); do \
	   $(RM) -f debian/$(UNISON_GTK_PACKAGE).$$(basename $$i); \
	   $(RM) -f debian/$(UNISON_PACKAGE).$$(basename $$i); \
	done
	-$(RM) unison-gtk-template-stamp unison-template-stamp

unison-gtk-template-stamp: PRIORITY_SELF = $(PRIORITY_GTK)
unison-gtk-template-stamp: UNISON_SELF = $(UNISON_GTK)
unison-gtk-template-stamp: UNISON_SELF_PACKAGE = $(UNISON_GTK_PACKAGE)
unison-gtk-template-stamp: UNISON_SELF_ALTERNATIVE = $(UNISON_GTK_ALTERNATIVE)
unison-gtk-template-stamp: UNISON_SELF_VERSIONNO = $(UNISON_GTK_VERSIONNO)
unison-gtk-template-stamp: UNISON_SELF_VAR = $(UNISON_GTK_VAR)
unison-gtk-template-stamp: IS_GTK=true

unison-template-stamp: PRIORITY_SELF = $(PRIORITY)
unison-template-stamp: UNISON_SELF = $(UNISON)
unison-template-stamp: UNISON_SELF_PACKAGE = $(UNISON_PACKAGE)
unison-template-stamp: UNISON_SELF_ALTERNATIVE = $(UNISON_ALTERNATIVE)
unison-template-stamp: UNISON_SELF_VERSIONNO = $(UNISON_VERSIONNO)
unison-template-stamp: UNISON_SELF_VAR = $(UNISON_VAR)
unison-template-stamp: IS_GTK=false

template: unison-template-stamp unison-gtk-template-stamp

.PHONY: template

common-binary-indep:: template
common-binary-arch:: template

#
# Rename and substitute files
#

unison-rename: unison-rename-stamp
unison-rename-stamp: $(RENAME)
	# Rename all the debhelper files needed and substitue the @XXX@
	# string
	for i in $^ ; do \
	  DST=`echo $$i | sed -e "s/unison/${UNISON_PACKAGE}/" -e "s/\\.in\\$$//"`; \
	  sed $(SED_REPLACE) $$i > "$(CURDIR)/$$DST"; \
	done
	
	# We always need to rename the manual
	cp '$(CURDIR)/debian/$(UNISON_PACKAGE).1' '$(CURDIR)/debian/$(UNISON).1'
	# We copy unison.1 to unison-gtk.1
	cp '$(CURDIR)/debian/$(UNISON).1' '$(CURDIR)/debian/$(UNISON_GTK).1'
	
	touch $@

clean::
	# Remove the renamed files
	-for i in $(RENAME); do \
	  DST=`echo $$i | sed -e "s/unison/${UNISON_PACKAGE}/" -e "s/\\.in\\$$//"`; \
	  $(RM) "$(CURDIR)/$$DST"; \
	done
	-$(RM) '$(CURDIR)/debian/$(UNISON).1'
	-$(RM) '$(CURDIR)/debian/$(UNISON_GTK).1'
	-$(RM) '$(CURDIR)/unison-rename-stamp'

.PHONY: unison-rename

common-binary-indep:: unison-rename template
common-binary-arch:: unison-rename template

## unison 2.40.102

=== Makefile ===
#######################################################################
# $I1: Unison file synchronizer: src/Makefile $
# $I2: Last modified by bcpierce on Sun, 22 Aug 2004 22:29:04 -0400 $
# $I3: Copyright 1999-2004 (see COPYING for details) $
#######################################################################
## User Settings

# Set NATIVE=false if you are not using the native code compiler (ocamlopt)
# This is not advised, though: Unison runs much slower when byte-compiled.
#
# If you set NATIVE=false, then make sure that the THREADS option below is
# also set to false unless your OCaml installation has true posix-compliant
# threads (i.e., -with-pthreads was given as an option to the config script).
NATIVE=true

# Use THREADS=false if your OCaml installation is not configured with the
# -with-pthreads option.  (Unison will crash when compiled with THREADS=true
# if the -with-pthreads configuration option was not used.)
THREADS=false

# User interface style.  For legal values, see Makefile.OCaml.
# You probably don't need to set this yourself -- it will be set to
# an appropriate value automatically, depending on whether the lablgtk
# library is available.
#
# UISTYLE=text

########################################################################
########################################################################
#     (There should be no need to change anything from here on)       ##
########################################################################

######################################################################
# Building installation instructions

all:: strings.ml buildexecutable

all:: INSTALL

.PHONY: all clean install doinstall installtext text \
	setupdemo-old setupdemo modifydemo demo \
	run runbatch runt rundebug runp runtext runsort runprefer \
	prefsdocs runtest repeattest \
	selftest selftestdebug selftestremote testmerge \
	checkin installremote

.DELETE_ON_ERROR:
# to avoid problems when e.g. mkProjectInfo fails to run

INSTALL: $(NAME)$(EXEC_EXT)
# file isn't made for OS X, so check that it's there first
	(if [ -f $(NAME) ]; then ./$(NAME) -doc install > INSTALLATION; fi)

########################################################################
## Miscellaneous developer-only switches
DEBUGGING=true
PROFILING=false
STATIC=false

# NAME, VERSION, and MAJORVERSION, automatically generated
-include Makefile.ProjectInfo

Makefile.ProjectInfo: mkProjectInfo $(wildcard ../.bzr/branch/last-revision)
	./mkProjectInfo > $@
# BCP (4/11): simplified from this:
#	ocaml str.cma unix.cma ./mkProjectInfo.ml > $@

mkProjectInfo: mkProjectInfo.ml
	ocamlc -o $@ unix.cma str.cma $^

clean::
	$(RM) mkProjectInfo
	$(RM) Makefile.ProjectInfo

########################################################################
### Compilation rules

include Makefile.OCaml

######################################################################
# Installation

INSTALLDIR = $(HOME)/bin/

# This has two names because on OSX the file INSTALL shadows the target 'install'!
install: doinstall

installtext: 
	$(MAKE) -C .. installtext

text: 
	$(MAKE) -C .. text

doinstall: $(NAME)$(EXEC_EXT)
	-mv $(INSTALLDIR)/$(NAME)$(EXEC_EXT) /tmp/$(NAME)-$(shell echo $$$$)
	cp $(NAME)$(EXEC_EXT) $(INSTALLDIR)
	cp $(NAME)$(EXEC_EXT) $(INSTALLDIR)$(NAME)-$(MAJORVERSION)$(EXEC_EXT)


######################################################################
# Demo

setupdemo-old: all
	-mkdir alice.tmp bob.tmp
	-touch alice.tmp/letter alice.tmp/curriculum
	-mkdir bob.tmp/curriculum
	-touch bob.tmp/curriculum/french
	-touch bob.tmp/curriculum/german
	-mkdir bob.tmp/good_friends
	-mkdir bob.tmp/good_friends/addresses
	-mkdir alice.tmp/good_friends
	-touch alice.tmp/good_friends/addresses
	-touch bob.tmp/good_friends/addresses/alice
	-mkdir alice.tmp/book
	-mkdir bob.tmp/book
	echo "first name:alice \n 2234 Chesnut Street \n Philadelphia" \
	   > bob.tmp/good_friends/addresses/alice
	echo "ADDRESS 1 : BOB \n firstName : bob \n 2233 Walnut Street" \
	   > alice.tmp/good_friends/addresses
	echo "Born in Paris in 1976 ..." > alice.tmp/curriculum
	echo "Ne a Paris en 1976 ..." > bob.tmp/curriculum/french
	echo "Geboren in Paris im jahre 1976 ..." > bob.tmp/curriculum/german
	echo "Dear friend, I received your letter ..."    > alice.tmp/letter
	echo "And then the big bad wolf" > bob.tmp/book/page3
	echo "Title : three little pigs" > alice.tmp/book/page1
	echo "there was upon a time ..." > alice.tmp/book/page2

setupdemo:
	rm -rf a.tmp b.tmp
	mkdir a.tmp
	touch a.tmp/a a.tmp/b a.tmp/c
	mkdir a.tmp/d
	touch a.tmp/d/f
	touch a.tmp/d/g
	cp -r a.tmp b.tmp

modifydemo:
	-rm a.tmp/a
	echo "Hello" > a.tmp/b
	echo "Hello" > b.tmp/b
	date > b.tmp/c
	echo "Hi there" > a.tmp/d/h
	echo "Hello there" > b.tmp/d/h

demo: all setupdemo
	@$(MAKE) run
	@$(MAKE) modifydemo
	@$(MAKE) run

run: all
	-mkdir a.tmp b.tmp
	-date > a.tmp/x
	-date > b.tmp/y
	./$(NAME) default a.tmp b.tmp

runbatch: all
	-mkdir a.tmp b.tmp
	-date > a.tmp/x
	-date > b.tmp/y
	./$(NAME) default a.tmp b.tmp -batch

runt: all
	-mkdir a.tmp b.tmp
	-date > a.tmp/x
	-date > b.tmp/y
	./$(NAME) default a.tmp b.tmp -timers

rundebug: all
	-date > a.tmp/x
	-date > b.tmp/y
	./$(NAME) a.tmp b.tmp -debug all  -ui text

runp: all
	-echo cat > a.tmp/cat
	-echo cat > b.tmp/cat
	-chmod 765 a.tmp/cat
	-chmod 700 b.tmp/cat
	./$(NAME) a.tmp b.tmp

runtext: all
	-mkdir a.tmp b.tmp
	-date > a.tmp/x
	-date > b.tmp/y
	./$(NAME) -ui text a.tmp b.tmp

runsort: all
	-mkdir a.tmp b.tmp
	-date > a.tmp/b
	-date > b.tmp/m
	-date > b.tmp/z
	-date > b.tmp/f
	-date >> b.tmp/f
	-date > b.tmp/c.$(shell echo $$$$)
	-date > b.tmp/y.$(shell echo $$$$)
	./$(NAME) default a.tmp b.tmp -debug sort

runprefer: all
	-mkdir a.tmp b.tmp
	-date > a.tmp/b
	-date > b.tmp/m
	-date > b.tmp/z
	-echo Hello > a.tmp/z
	-date > b.tmp/f
	-date >> b.tmp/f
	-date > b.tmp/c.$(shell echo $$$$)
	-date > b.tmp/y.$(shell echo $$$$)
	./$(NAME) default a.tmp b.tmp -force b.tmp

prefsdocs: all
	./$(NAME) -prefsdocs 2> prefsdocsjunk.tmp
	mv -f prefsdocsjunk.tmp prefsdocs.tmp

# For developers 
runtest:
	$(MAKE) NATIVE=false DEBUG=true text
	./unison test

repeattest:
	$(MAKE) all NATIVE=false DEBUG=true UISTYLE=text
	./unison noprofile a.tmp b.tmp -repeat foo.tmp -debug ui

selftest:
	$(MAKE) all NATIVE=false DEBUG=true UISTYLE=text
	./unison -selftest -ui text -batch 

selftestdebug:
	$(MAKE) all NATIVE=false DEBUG=true UISTYLE=text
	./unison -selftest -ui text -batch -debug all

selftestremote:
	$(MAKE) all NATIVE=false DEBUG=true UISTYLE=text
	./unison -selftest -ui text -batch test.tmp ssh://eniac.seas.upenn.edu/test.tmp 

testmerge:
	$(MAKE) all NATIVE=false UISTYLE=text
	-rm -rf a.tmp b.tmp
	-rm -rf $(HOME)/.unison/backup/file.txt*
	mkdir a.tmp b.tmp
	@echo
	@echo -----------------------------------------------------------
	@echo
	./unison testmerge -ui text -batch
	echo 1OO >> a.tmp/file.txt
	echo 2oo >> a.tmp/file.txt
	echo 3oo >> a.tmp/file.txt
	echo 4oo >> a.tmp/file.txt
	echo 5oo >> a.tmp/file.txt
	echo 6oo >> a.tmp/file.txt
	echo 7oo >> a.tmp/file.txt
	echo 8oo >> a.tmp/file.txt
	echo 9oo >> a.tmp/file.txt
	echo 0oo >> a.tmp/file.txt
	echo 1oo >> a.tmp/file.txt
	echo 2oo >> a.tmp/file.txt
	echo 3oo >> a.tmp/file.txt
	echo 4oo >> a.tmp/file.txt
	echo 5oo >> a.tmp/file.txt
	echo 6oo >> a.tmp/file.txt
	echo 5oo >> a.tmp/file.txt
	echo 6oo >> a.tmp/file.txt
	echo 7oo >> a.tmp/file.txt
	echo 8oo >> a.tmp/file.txt
	echo 9oo >> a.tmp/file.txt
	echo 0oo >> a.tmp/file.txt
	echo 1oo >> a.tmp/file.txt
	echo 2oo >> a.tmp/file.txt
	echo 3OO >> a.tmp/file.txt
	echo 4oo >> a.tmp/file.txt
	./unison testmerge -ui text -batch
	rm a.tmp/file.txt b.tmp/file.txt
	echo 1OO >> a.tmp/file.txt
	echo second >> a.tmp/file.txt
	echo 3oo >> a.tmp/file.txt
	echo 4oo >> a.tmp/file.txt
	echo 5oo >> a.tmp/file.txt
	echo 6oo >> a.tmp/file.txt
	echo 7oo >> a.tmp/file.txt
	echo 8oo >> a.tmp/file.txt
	echo 9oo >> a.tmp/file.txt
	echo 0oo >> a.tmp/file.txt
	echo 1oo >> a.tmp/file.txt
	echo 2oo >> a.tmp/file.txt
	echo 3oo >> a.tmp/file.txt
	echo 4oo >> a.tmp/file.txt
	echo 5oo >> a.tmp/file.txt
	echo 6oo >> a.tmp/file.txt
	echo 5oo >> a.tmp/file.txt
	echo 6oo >> a.tmp/file.txt
	echo 7oo >> a.tmp/file.txt
	echo 8oo >> a.tmp/file.txt
	echo 9oo >> a.tmp/file.txt
	echo 0oo >> a.tmp/file.txt
	echo 1oo >> a.tmp/file.txt
	echo 2oo >> a.tmp/file.txt
	echo 3OO >> a.tmp/file.txt
	echo 4oo >> a.tmp/file.txt
	echo ---
	echo 1OO >> b.tmp/file.txt
	echo 2oo >> b.tmp/file.txt
	echo 3oo >> b.tmp/file.txt
	echo 4oo >> b.tmp/file.txt
	echo 5oo >> b.tmp/file.txt
	echo 6oo >> b.tmp/file.txt
	echo 7oo >> b.tmp/file.txt
	echo 8oo >> b.tmp/file.txt
	echo 9oo >> b.tmp/file.txt
	echo 0oo >> b.tmp/file.txt
	echo 1oo >> b.tmp/file.txt
	echo 2oo >> b.tmp/file.txt
	echo 3oo >> b.tmp/file.txt
	echo 4oo >> b.tmp/file.txt
	echo 5oo >> b.tmp/file.txt
	echo 6oo >> b.tmp/file.txt
	echo 5oo >> b.tmp/file.txt
	echo 6oo >> b.tmp/file.txt
	echo 7oo >> b.tmp/file.txt
	echo 8oo >> b.tmp/file.txt
	echo 9oo >> b.tmp/file.txt
	echo 0oo >> b.tmp/file.txt
	echo 1oo >> b.tmp/file.txt
	echo 2oo >> b.tmp/file.txt
	echo 3OO >> b.tmp/file.txt
	echo end >> b.tmp/file.txt
	@echo
	@echo -----------------------------------------------------------
	@echo
	./unison testmerge -ui text -batch -debug files -debug update -debug backup
	@echo
	@echo -----------------------------------------------------------
	@echo
	./unison testmerge -ui text -batch
	@echo
	@echo -----------------------------------------------------------
	@echo
	cat a.tmp/file.txt
	cat b.tmp/file.txt
	cat $(HOME)/.unison/backup/file.txt


######################################################################
# Tags

# In Windows, tags and TAGS are the same, so make tags stops working
# after the first invocation.  The .PHONY declaration makes it work
# again.
.PHONY: tags

tags:
	-if [ -f `which $(ETAGS)` ]; then \
	    $(ETAGS) *.mli */*.mli *.ml */*.ml */*.m *.c */*.c *.txt \
          ; fi 

all:: TAGS

TAGS:
	$(MAKE) tags

######################################################################
# Misc

clean::
	-$(RM) *.log *.aux *.log *.dvi *.out *.bak
	-$(RM) -r obsolete
	-$(RM) $(NAME) $(NAME).exe
	-$(RM) $(NAME)-blob.o

clean::
	$(MAKE) -C ubase clean
	$(MAKE) -C lwt clean

ifeq (${OSARCH},osx)
clean::
	-(cd $(UIMACDIR); xcodebuild clean)
	-(cd $(UIMACDIR); $(RM) -r build ExternalSettings.xcconfig)
endif

checkin:
	$(MAKE) -C .. checkin

installremote: 
	$(MAKE) UISTYLE=text
	-unison eniac -path current/unison/trunk/src -batch
	ssh eniac.seas.upenn.edu make -C current/unison/trunk/src installtext

####################################################################
# Documentation strings

# Cons up a fake strings.ml if necessary (the real one is generated when
# we build the documentation, but we need to be able to compile the
# executable here to do that!)
strings.ml:
	echo "(* Dummy strings.ml *)" > strings.ml
	echo "let docs = []" >> strings.ml

=== debian/changelog ===
unison (2.40.102-2ubuntu1) saucy; urgency=low

  * Resynchronise with Debian. Remaining changes:
    - Change default logfile directory to .unison by prepending .unison to
      name of logfile in ubase/trace.ml.

 -- Julian Taylor <jtaylor@ubuntu.com>  Thu, 30 May 2013 13:12:07 +0200

unison (2.40.102-2) unstable; urgency=low

  * Bump Standards-Version to 3.9.4
  * Upload to unstable

 -- Stéphane Glondu <glondu@debian.org>  Sat, 11 May 2013 12:03:12 +0200

unison (2.40.102-1) experimental; urgency=low

  * New upstream release
    - compatibility with OCaml >= 4 (Closes: #691683)

 -- Stéphane Glondu <glondu@debian.org>  Wed, 17 Apr 2013 14:44:24 +0200

unison (2.40.65-2) unstable; urgency=low

  * Refer to unison-manual.txt.gz in doc-base (Closes: #657496)

 -- Stéphane Glondu <glondu@debian.org>  Sun, 15 Apr 2012 18:02:55 +0200

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
  librsvg2-bin (>= 2.18.2),
  imagemagick,
  dh-ocaml (>= 0.9.1)
-Standards-Version: 3.9.2
+Standards-Version: 3.9.4
 Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/unison.git
 Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/unison.git
 Homepage: http://www.cis.upenn.edu/~bcpierce/unison/

## unison 2.48.3

=== debian/changelog ===
unison (2.48.3-1ubuntu1) xenial; urgency=low

  * Merge from Debian unstable, resolving segfault when transferring files
    between servers (LP: #1421184). Remaining changes:
    - Change default logfile directory to .unison by prepending .unison to
      name of logfile in ubase/trace.ml.

 -- James Page <james.page@ubuntu.com>  Fri, 18 Mar 2016 14:51:10 +0000

unison (2.48.3-1) unstable; urgency=medium

  * New upstream release (Closes: #705318)
    - remove obsolete patches (fixed upstream)
    - fix debian/generate-manpage.ml
    - thanks to Yuri Kanivetsky for preliminary updating work
    - make temp file names fit within 143 characters (Closes: #504503)
  * Do not use absolute path to icon in desktop file (Closes: #777238)
  * Update debian/copyright
  * Update bash completion installation directory
  * Bump debhelper compat level to 9
  * Bump Standards-Version to 3.9.6

 -- Stéphane Glondu <glondu@debian.org>  Tue, 18 Aug 2015 14:57:24 +0200

unison (2.40.102-2ubuntu2) xenial; urgency=medium

  * No-change rebuild for ncurses6 transition.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Feb 2016 12:48:45 +0000

=== debian/control ===
--- 
+++ 
@@ -6,16 +6,16 @@
 Uploaders:
  Stéphane Glondu <glondu@debian.org>
 Build-Depends: cdbs (>= 0.4.23),
- debhelper (>= 7),
+ debhelper (>= 9),
  ocaml-nox (>= 3.10.0-8),
  liblablgtk2-ocaml-dev (>= 2.12.0-2),
  chrpath,
  librsvg2-bin (>= 2.18.2),
  imagemagick,
  dh-ocaml (>= 0.9.1)
-Standards-Version: 3.9.4
-Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/unison.git
-Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/unison.git
+Standards-Version: 3.9.6
+Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/unison.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ocaml-maint/packages/unison.git
 Homepage: http://www.cis.upenn.edu/~bcpierce/unison/
 
 Package: unison

## unison 2.48.4

=== Makefile ===
--- 
+++ 
@@ -62,8 +62,6 @@
 
 Makefile.ProjectInfo: mkProjectInfo $(wildcard ../.bzr/branch/last-revision)
 	./mkProjectInfo > $@
-# BCP (4/11): simplified from this:
-#	ocaml str.cma unix.cma ./mkProjectInfo.ml > $@
 
 mkProjectInfo: mkProjectInfo.ml
 	ocamlc -o $@ unix.cma str.cma $^
@@ -368,7 +366,7 @@
 	$(MAKE) -C ubase clean
 	$(MAKE) -C lwt clean
 
-ifeq (${OSARCH},osx)
+ifneq ($(strip $(UIMACDIR)),)
 clean::
 	-(cd $(UIMACDIR); xcodebuild clean)
 	-(cd $(UIMACDIR); $(RM) -r build ExternalSettings.xcconfig)

=== fsmonitor/linux/Makefile ===

FSMONITOR = $(NAME)-fsmonitor

DIR=fsmonitor/linux
FSMOCAMLOBJS = \
   lwt/lwt.cmo lwt/pqueue.cmo lwt/generic/lwt_unix_impl.cmo lwt/lwt_unix.cmo \
   $(DIR)/inotify.cmo $(DIR)/lwt_inotify.cmo \
   fsmonitor/watchercommon.cmo $(DIR)/watcher.cmo
FSMCOBJS = \
  $(DIR)/inotify_stubs.o
FSMOCAMLLIBS=unix.cma

ifeq ($(NATIVE), true)
  FSMCAMLOBJS=$(subst .cmo,.cmx, $(FSMOCAMLOBJS))
  FSMCAMLLIBS=$(subst .cma,.cmxa, $(FSMOCAMLLIBS))
else
  FSMCAMLOBJS=$(FSMOCAMLOBJS)
  FSMCAMLLIBS=$(FSMOCAMLLIBS)
endif

buildexecutable:: $(FSMONITOR)$(EXEC_EXT)

$(FSMONITOR)$(EXEC_EXT): $(FSMCAMLOBJS) $(FSMCOBJS)
	@echo Linking $@
	$(CAMLC) -verbose $(CAMLFLAGS) -o $@ $(CFLAGS) $(FSMCAMLLIBS) $^ $(CLIBS)

clean::
	rm -f $(DIR)/*.cm[iox] $(DIR)/*.o $(DIR)/*~
	rm -f $(FSMONITOR)$(EXEC_EXT)

=== fsmonitor/windows/Makefile ===

FSMONITOR = $(NAME)-fsmonitor

DIR=fsmonitor/windows
FSMOCAMLOBJS = \
   ubase/rx.cmo unicode_tables.cmo unicode.cmo \
   system/system_generic.cmo system/system_win.cmo \
   system/win/system_impl.cmo \
   lwt/lwt.cmo lwt/pqueue.cmo lwt/win/lwt_unix_impl.cmo lwt/lwt_unix.cmo \
   lwt/win/lwt_win.cmo \
   $(DIR)/shortnames.cmo fsmonitor/watchercommon.cmo $(DIR)/watcher.cmo
FSMCOBJS = \
   system/system_win_stubs.o lwt/lwt_unix_stubs.o $(DIR)/shortnames_stubs.o
FSMOCAMLLIBS=bigarray.cma unix.cma

ifeq ($(NATIVE), true)
  FSMCAMLOBJS=$(subst .cmo,.cmx, $(FSMOCAMLOBJS))
  FSMCAMLLIBS=$(subst .cma,.cmxa, $(FSMOCAMLLIBS))
else
  FSMCAMLOBJS=$(FSMOCAMLOBJS)
  FSMCAMLLIBS=$(FSMOCAMLLIBS)
endif

buildexecutable:: $(FSMONITOR)$(EXEC_EXT)

$(FSMONITOR)$(EXEC_EXT): $(FSMCAMLOBJS) $(FSMCOBJS)
	@echo Linking $@
	$(CAMLC) -verbose $(CAMLFLAGS) -o $@ $(CFLAGS) $(FSMCAMLLIBS) $^ $(CLIBS)

clean::
	rm -f $(DIR)/*.cm[iox] $(DIR)/*.o $(DIR)/*~
	rm -f $(FSMONITOR)$(EXEC_EXT)

=== debian/changelog ===
unison (2.48.4-4ubuntu1) focal; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Change default logfile directory to .unison by prepending .unison to
      name of logfile in ubase/trace.ml.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 16 Feb 2020 11:04:10 +0100

unison (2.48.4-4) unstable; urgency=medium

  * Rename debian/NEWS.Debian to debian/NEWS so that it is installed

 -- Stéphane Glondu <glondu@debian.org>  Wed, 04 Dec 2019 09:44:32 +0100

unison (2.48.4-3) unstable; urgency=medium

  * Add entry in NEWS.Debian documenting the incompatibility due to
    compilation with a different OCaml version (Closes: #946041)

 -- Stéphane Glondu <glondu@debian.org>  Tue, 03 Dec 2019 11:44:57 +0100

unison (2.48.4-2) unstable; urgency=medium

  * Fix compilation with OCaml 4.08.1
  * Update Vcs-*

 -- Stéphane Glondu <glondu@debian.org>  Mon, 02 Dec 2019 13:26:31 +0100

unison (2.48.4-1ubuntu1) bionic; urgency=medium

  * Merge from Debian unstable.  Remaining changes:
    - Change default logfile directory to .unison by prepending .unison to
      name of logfile in ubase/trace.ml.

 -- Bhavani Shankar <bhavi@ubuntu.com>  Tue, 31 Oct 2017 09:23:02 +0530

unison (2.48.4-1) unstable; urgency=medium

  * New upstream release (Closes: #878462)
  * Update Vcs-*
  * Bump Standards-Version to 4.1.1
  * Remove menu file

 -- Stéphane Glondu <glondu@debian.org>  Mon, 30 Oct 2017 10:26:00 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: unison
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders:
  Stéphane Glondu <glondu@debian.org>
 Build-Depends: cdbs (>= 0.4.23),
@@ -13,9 +12,9 @@
  librsvg2-bin (>= 2.18.2),
  imagemagick,
  dh-ocaml (>= 0.9.1)
-Standards-Version: 3.9.6
-Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/unison.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ocaml-maint/packages/unison.git
+Standards-Version: 4.1.1
+Vcs-Git: https://salsa.debian.org/ocaml-team/unison.git
+Vcs-Browser: https://salsa.debian.org/ocaml-team/unison
 Homepage: http://www.cis.upenn.edu/~bcpierce/unison/
 
 Package: unison

=== debian/rules ===
--- 
+++ 
@@ -54,7 +54,6 @@
 
 RENAME := debian/unison.1.in
 RENAME += debian/unison.doc-base.in
-RENAME += debian/unison-gtk.menu.in
 RENAME += debian/unison-gtk.svg.in
 RENAME += debian/unison-gtk.install.in
 RENAME += debian/unison.install.in
@@ -84,8 +83,6 @@
 DEB_INSTALL_DOCS_ALL := BUGS.txt TODO.txt unison-manual.txt -X unison.doc-base.in
 
 DEB_INSTALL_CHANGELOGS_ALL := NEWS
-
-DEB_COMPRESS_EXCLUDE_ALL := unison-manual.txt
 
 #
 # Build unison
